﻿////////////////////////////////////////////////////////////////////////
//                       Eplan-Schnellauswahl
////////////////////////////////////////////////////////////////////////
// Erstellt am:         2019-02-20
// Erstellt von:        Michel Thewalt
// Geändert am:         2019-02-20
// Geändert von:        Michel Thewalt
//
// Getestet unter:      EPlan Pro Panel StandAlone 2.7.3 HF4
//                      EPlan Pro Panel StandAlone 2.8
//
// Verwendete Scripte:  GetProjectProperty von Johann Weiher
//                      https://suplanus.de/getprojectproperty-2/
//                      Selectionset von Johann Weiher
//                      https://suplanus.de/selectionset-pages/                  
//
// Funktionen:          Kundenlogo ändern
//
//
//Änderungen:           
// 
////////////////////////////////////////////////////////////////////////

public partial class FrmEPL : System.Windows.Forms.Form
{
    #region Variablen

    /// <summary>
    /// Stuct for Project Propertys
    /// </summary>
    public struct stcEIG
    {
        public string ID;
        public string Index;
        public string Value;
    };

    public stcEIG[] ProjectProperty = new stcEIG[2];

    //Datapath for Images
    //public string KImagePath = "I:\\EPLAN\\Data\\Bilder\\MTH_TEST\\NEUE_LOGOS\\";
    public string KImagePath = @"$(MD_IMG)\\NEUE_LOGOS\\";

    #endregion

    #region Steuerelemente
    private Button btn_M6_1;
    private ComboBox cB_M6_1;
    private PictureBox pB_M6_1;
    #endregion

    public FrmEPL()
    {
        InitializeComponent();
    }

    #region Form Desinger und Ressourcen
    /// <summary>
    /// Required designer variable
    /// </summary>
    private System.ComponentModel.IContainer components = null;

    /// <summary>
    /// Clean used resources.
    /// </summary>
    /// <param name="disposing">True, when managed resources are to be deleted; otherwise False.</param>
    protected override void Dispose(bool disposing)
    {
        if (disposing && (components != null))
        {
            components.Dispose();
        }
        base.Dispose(disposing);
    }
    #endregion

    #region Vom Windows Form-Designer generierter Code

    /// <summary>
    /// Required method for designer support.
    /// The content of the method must not be changed with the code editor.
    /// </summary>
    private void InitializeComponent()
    {
            this.btn_M6_1 = new System.Windows.Forms.Button();
            this.cB_M6_1 = new System.Windows.Forms.ComboBox();
            this.pB_M6_1 = new System.Windows.Forms.PictureBox();
            ((System.ComponentModel.ISupportInitialize)(this.pB_M6_1)).BeginInit();
            this.SuspendLayout();
            // 
            // btn_M6_1
            // 
            this.btn_M6_1.Location = new System.Drawing.Point(131, 9);
            this.btn_M6_1.Name = "btn_M6_1";
            this.btn_M6_1.Size = new System.Drawing.Size(115, 21);
            this.btn_M6_1.TabIndex = 7;
            this.btn_M6_1.Text = "Write";
            this.btn_M6_1.UseVisualStyleBackColor = true;
            this.btn_M6_1.Click += new System.EventHandler(this.btn_M6_1_Click);
            // 
            // cB_M6_1
            // 
            this.cB_M6_1.FormattingEnabled = true;
            this.cB_M6_1.Location = new System.Drawing.Point(12, 9);
            this.cB_M6_1.Name = "cB_M6_1";
            this.cB_M6_1.Size = new System.Drawing.Size(115, 21);
            this.cB_M6_1.TabIndex = 5;
            this.cB_M6_1.SelectedIndexChanged += new System.EventHandler(this.cB_M6_1_SelectedIndexChanged);
            // 
            // pB_M6_1
            // 
            this.pB_M6_1.Location = new System.Drawing.Point(12, 36);
            this.pB_M6_1.Name = "pB_M6_1";
            this.pB_M6_1.Size = new System.Drawing.Size(234, 120);
            this.pB_M6_1.SizeMode = System.Windows.Forms.PictureBoxSizeMode.Zoom;
            this.pB_M6_1.TabIndex = 6;
            this.pB_M6_1.TabStop = false;
            // 
            // FrmEPL
            // 
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(259, 170);
            this.Controls.Add(this.btn_M6_1);
            this.Controls.Add(this.cB_M6_1);
            this.Controls.Add(this.pB_M6_1);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "FrmEPL";
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Load += new System.EventHandler(this.FrmEPL_Load);
            ((System.ComponentModel.ISupportInitialize)(this.pB_M6_1)).EndInit();
            this.ResumeLayout(false);

    }

    #endregion

    #region Einstellungen

    public void Form_Property()
    {
        //Value for the dropdown menue
        this.cB_M6_1.Items.Add("Hersteller");
        this.cB_M6_1.Items.Add("Kunde1");
        this.cB_M6_1.Items.Add("Kunde2");
        this.cB_M6_1.Items.Add("Kunde3");
        this.cB_M6_1.Items.Add("Kunde4");

        //start object 
        this.cB_M6_1.SelectedItem = "Hersteller";

        //image view at start
        this.pB_M6_1.Image = System.Drawing.Image.FromStream(OpenKImage(this.cB_M6_1.SelectedItem.ToString(), KImagePath));

    }

    #endregion

    /// <summary>
    /// Action
    /// <summary>
    [DeclareAction("KundenLOGO")]

    /// <summary>
    /// Form loade
    /// <summary>
    public void FrmTemplateVoid()
    {
                FrmEPL Frm1 = new FrmEPL();
        Frm1.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
        Frm1.ShowDialog();
        return;
    }

    /// <summary>
    /// Form loade
    /// <summary>
    private void FrmEPL_Load(object sender, System.EventArgs e)
    {
        Form_Property();
    }

    #region Kunden Logo
    /// <summary>
    /// Dropdown menu for customers to select the customers logos
    /// <summary>
    private void cB_M6_1_SelectedIndexChanged(object sender, EventArgs e)
    {
        try
        {
            this.pB_M6_1.Image = System.Drawing.Image.FromStream(OpenKImage(this.cB_M6_1.SelectedItem.ToString(), KImagePath));
        }
        catch(System.Exception ex)
        {
            MessageBox.Show("Image could not be loaded\n" + ex.Message);
        }
    }

    /// <summary>
    /// Writing the customer logo in the project
    /// <summary>
    private void btn_M6_1_Click(object sender, EventArgs e)
    {
        string Projectpath = "";
        string Projectname = "";
        string Projectpath_with_Name = "";
        string ProjectImagePath = "";

        //Projectname read from Project
        ProjectProperty[0].ID = "10000";
        ProjectProperty[0].Index = "0";
        Projectname = GetProjectProperty(ProjectProperty[0]);

        //Projectpath read from Project
        ProjectProperty[1].ID = "10045";
        ProjectProperty[1].Index = "0";
        Projectpath = GetProjectProperty(ProjectProperty[1]);

        //Create the corresponding path for the project images
        ProjectImagePath = Projectpath + "\\" + Projectname + ".edb\\Images";

        //Create the corresponding path for the project
        Projectpath_with_Name = Projectpath + "\\" + Projectname + ".elk";

        //Close project for image exchange           
        Project_Close();
        
        //Copy logo to project images (LOGO-46x16.jpg)
        Copy_K_Logo(this.cB_M6_1.SelectedItem.ToString(), KImagePath, ProjectImagePath);

        //Open project with previously selected page
        Project_Open(Projectpath_with_Name, GetPages());
        System.Windows.Forms.MessageBox.Show("Customer logo has been changed!", "Note", System.Windows.Forms.MessageBoxButtons.OK, System.Windows.Forms.MessageBoxIcon.Information);

    }
    #endregion

    #region Funktionen
    /// <summary>
    /// Reading the currently opened page
    /// <summary>
    private static string GetPages()
    {
        ActionCallingContext actionCallingContext = new ActionCallingContext();
        string pagesString = "";
        actionCallingContext.AddParameter("TYPE", "PAGES");
        new CommandLineInterpreter().Execute("selectionset", actionCallingContext);
        actionCallingContext.GetParameter("PAGES", ref pagesString);
        return pagesString;
    }

    /// <summary>
    /// Function for assigning the image to the customer
    /// <summary>
    /// <param name="cB_">cB_ Dropdown menu for customers. </param>
    private string cB_Name_Image_Switch(string cB_)
    {
        string KImageName = "";

        switch (cB_)
        {
            case "Hersteller":
                KImageName = "LOGO-46x16.jpg";
                break;
            case "Kunde1":
                KImageName = "Kunde1-46x16.jpg";
                break;
            case "Kunde2":
                KImageName = "Kunde2-46x16.jpg";
                break;
            case "Kunde3":
                KImageName = "Kunde3-46x16.jpg";
                break;
            case "Kunde4":
                KImageName = "Kunde4-46x16.jpg";
                break;
        }
        return KImageName;
    }

    /// <summary>
    /// Function to open an image
    /// <summary>
    /// <param name="cB_">cB_ Dropdown menu for customers. </param>
    /// <param name="KImagePath_">KImagePath_ Datapath for Images. </param>
    private System.IO.FileStream OpenKImage(string cB_, string KImagePath_)
    {
        string KImageName = cB_Name_Image_Switch(cB_);
        try
        {
            //Image open
            System.IO.FileStream imageStream = new System.IO.FileStream(KImagePath_ + KImageName, System.IO.FileMode.Open, System.IO.FileAccess.Read);
            return imageStream;
        }
        catch (System.IO.IOException e)
        {
            MessageBox.Show(e.Message);
            return null;
        }

    }

    /// <summary>
    /// Function for copying the image into the project
    /// <summary>
    /// <param name="cB_">cB_ Dropdown menu for customers. </param>
    /// <param name="KImagePath_">KImagePath_ Datapath for images. </param>
    /// <param name="PimagePath_">PimagePath_ Datapath for project images. </param>
    private void Copy_K_Logo(string cB_, string KImagePath_, string PimagePath_)
    {
        string KImageName = cB_Name_Image_Switch(cB_);

        System.IO.File.Copy(KImagePath_ + "\\" + KImageName, PimagePath_ + "\\LOGO-46x16.jpg", true);
    }

    /// <summary>
    /// Function for reading the project properties
    /// <summary>
    /// <param name="Property">Property struct of the project properties. </param>
    private static string GetProjectProperty(stcEIG Property)
    {
        string value = null;
        ActionCallingContext actionCallingContext = new ActionCallingContext();
        actionCallingContext.AddParameter("id", Property.ID);
        actionCallingContext.AddParameter("index", Property.Index);
        new CommandLineInterpreter().Execute("GetProjectProperty", actionCallingContext);
        actionCallingContext.GetParameter("value", ref value);
        return value;
    }

    /// <summary>
    /// Function for closing the actual project
    /// <summary>
    public void Project_Close()
    {
        ActionCallingContext acc = new ActionCallingContext();
        acc.AddParameter("NOCLOSE", "0");

        CommandLineInterpreter cmdLineItp = new CommandLineInterpreter();
        cmdLineItp.Execute("XPrjActionProjectClose", acc);
    }

    /// <summary>
    /// Function for closing the actual project
    /// <summary>
    /// <param name="Projekt">Projekt project path with project name </param>
    /// <param name="Page">Page page name. </param>
    public void Project_Open(string Projekt, string Page)
    {
        ActionCallingContext acc = new ActionCallingContext();
        acc.AddParameter("PROJEKT", Projekt);
        acc.AddParameter("EDIT", Page);
        acc.AddParameter("NOCLOSE", "1");

        CommandLineInterpreter cmdLineItp = new CommandLineInterpreter();
        cmdLineItp.Execute("ProjectAction", acc);
    }
    #endregion
}